/* aet3d.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__9 = 9;

/* Subroutine */ int aet3d_c(integer *nm, integer *n, doublereal *a,
        doublereal *wr, doublereal *wi, logical *select, integer *mm, integer 
        *m, doublereal *z__, doublereal *rm1, doublereal *rv1, doublereal *
        rv2, integer *ierr)
{
    /* Initialized data */

    static doublereal sys051 = 1.1107652e-16;

    /* System generated locals */
    integer a_dim1, a_offset, rm1_dim1, rm1_offset, z_dim1, z_offset, i__1, 
            i__2, i__3;
    doublereal d__1, d__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    extern doublereal aa01p_c(doublereal *, doublereal *);
    extern /* Subroutine */ int aa02p_c(doublereal *, doublereal *, doublereal
            *, doublereal *, doublereal *, doublereal *);
    static doublereal norm;
    static integer i__, j, k, l, s;
    static doublereal t, w, x, y;
    extern /* Subroutine */ int utae12_c(integer *, integer *, integer *);
    static integer n1;
    static doublereal normv, x2;
    static integer ii;
    static doublereal ilambd;
    static integer ip, mp, ns, uk;
    static doublereal rlambd;
    static integer km1, ip1;
    static doublereal growto, ukroot;
    static logical log__;
    static integer its;
    static doublereal eps3, eps4;


#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]
#define z___ref(a_1,a_2) z__[(a_2)*z_dim1 + a_1]
#define rm1_ref(a_1,a_2) rm1[(a_2)*rm1_dim1 + a_1]

    /* Parameter adjustments */
    --rv2;
    --rv1;
    rm1_dim1 = *n;
    rm1_offset = rm1_dim1 + 1;
    rm1 -= rm1_offset;
    --select;
    --wi;
    --wr;
    a_dim1 = *nm;
    a_offset = a_dim1 + 1;
    a -= a_offset;
    z_dim1 = *nm;
    z_offset = z_dim1 + 1;
    z__ -= z_offset;

    /* Function Body */
/* ***** SYS51 - MAHHO-ABCMA KOHCTAHTA, XAPAKTEPYA OTHOCT. */
/*                TOHOCT APMETK C ABAE ATO */
    *ierr = 0;
    uk = 0;
    s = 1;
/* *******IP=,BE. C.H. */
/*          1,EPBOE C.H.  KOM.-COP. A */
/*         -1,BTOPOE C.H.  KOM.-COP. AP */
    ip = 0;
    n1 = *n - 1;
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
        if (wi[k] == 0. || ip < 0) {
            goto L10;
        }
        ip = 1;
        if (select[k] && select[k + 1]) {
            select[k + 1] = FALSE_;
        }
L10:
        log__ = ! select[k];
        if (log__) {
            goto L560;
        }
        if (wi[k] != 0.) {
            ++s;
        }
        if (s > *mm) {
            goto L580;
        }
        if (uk >= k) {
            goto L60;
        }
/* *****POBEPKA HA BOMOHOCT PACEEH */
        i__2 = *n;
        for (uk = k; uk <= i__2; ++uk) {
            if (uk == *n) {
                goto L30;
            }
            if (a_ref(uk + 1, uk) == 0.) {
                goto L30;
            }
/* L20: */
        }
/* *****B-E ECKOHEHO HOPM ABHOO MHOPA OPKA UK */
L30:
        norm = 0.;
        mp = 1;
        i__2 = uk;
        for (i__ = 1; i__ <= i__2; ++i__) {
            x = 0.;
            i__3 = uk;
            for (j = mp; j <= i__3; ++j) {
                x += (d__1 = a_ref(i__, j), abs(d__1));
/* L40: */
            }
            if (x > norm) {
                norm = x;
            }
            mp = i__;
/* L50: */
        }
/* *****EPS4-BEHA  AMEH MAOO BEYEO EMEHTA */
/*     EPS3-BEHA  BOMYEH  .. */
        if (norm == 0.) {
            norm = 1.;
        }
        eps3 = sys051 * norm;
        eps4 = eps3 / 2.;
/* *****GROWTO -AKTOP POCTA */
        ukroot = (doublereal) uk;
        ukroot = sqrt(ukroot);
        growto = .1 / ukroot;
L60:
        rlambd = wr[k];
        ilambd = wi[k];
        if (k == 1) {
            goto L100;
        }
        km1 = k - 1;
        goto L80;
/* *****BOMYEHE C.H.,KOTOPOE KO K KAKOMY-O  PEYX */
L70:
        rlambd += eps3;
/* *****I=K-1,1,-1 */
L80:
        i__2 = km1;
        for (ii = 1; ii <= i__2; ++ii) {
            i__ = k - ii;
            if (select[i__] && (d__1 = wr[i__] - rlambd, abs(d__1)) < eps3 && 
                    (d__2 = wi[i__] - ilambd, abs(d__2)) < eps3) {
                goto L70;
            }
/* L90: */
        }
        wr[k] = rlambd;
/* *****COOTBETCTBYEE BOMYEHE KOM.-COP. C.H. */
        ip1 = k + ip;
        wr[ip1] = rlambd;
L100:
        mp = 1;
        i__2 = uk;
        for (i__ = 1; i__ <= i__2; ++i__) {
            i__3 = uk;
            for (j = mp; j <= i__3; ++j) {
                rm1_ref(j, i__) = a_ref(i__, j);
/* L110: */
            }
            rm1_ref(i__, i__) = rm1_ref(i__, i__) - rlambd;
            mp = i__;
            rv1[i__] = eps3;
/* L120: */
        }
        its = 0;
        if (ilambd != 0.) {
            goto L220;
        }
/* *****BE.C.H. */
/*     TPEY.PAEHE METOOM AYCCA C EPECTAHOBKAM */
        if (uk == 1) {
            goto L170;
        }
        i__2 = uk;
        for (i__ = 2; i__ <= i__2; ++i__) {
            mp = i__ - 1;
            if ((d__1 = rm1_ref(mp, i__), abs(d__1)) <= (d__2 = rm1_ref(mp, 
                    mp), abs(d__2))) {
                goto L140;
            }
            i__3 = uk;
            for (j = mp; j <= i__3; ++j) {
                y = rm1_ref(j, i__);
                rm1_ref(j, i__) = rm1_ref(j, mp);
                rm1_ref(j, mp) = y;
/* L130: */
            }
L140:
            if ((d__1 = rm1_ref(mp, mp), abs(d__1)) <= eps4) {
                rm1_ref(uk, uk) = eps4;
            }
            x = rm1_ref(mp, i__) / rm1_ref(mp, mp);
            if (x == 0.) {
                goto L160;
            }
            i__3 = uk;
            for (j = i__; j <= i__3; ++j) {
                rm1_ref(j, i__) = rm1_ref(j, i__) - x * rm1_ref(j, mp);
/* L150: */
            }
L160:
            ;
        }
L170:
        if ((d__1 = rm1_ref(uk, uk), abs(d__1)) <= eps4) {
            rm1_ref(uk, uk) = eps4;
        }
/* *****OPATHA OCTAHOBKA  BE. C.B. */
/*      I=UK,1,-1 */
L180:
        i__2 = uk;
        for (ii = 1; ii <= i__2; ++ii) {
            i__ = uk + 1 - ii;
            y = rv1[i__];
            if (i__ == uk) {
                goto L200;
            }
            ip1 = i__ + 1;
            i__3 = uk;
            for (j = ip1; j <= i__3; ++j) {
                y -= rm1_ref(j, i__) * rv1[j];
/* L190: */
            }
L200:
            rv1[i__] = y / rm1_ref(i__, i__);
/* L210: */
        }
        goto L450;
/* *****KOM. C. H. */
/*     TPEY.PAOEHE METOOM AYCCA C EPECTAHOBKAM */
/*     EPS4-BEHA  AMEH HYEBOO BE.MEHTA */
/*     MHMA ACT AOMHAETC B BEPXHEM TPEYOHKE, */
/*     HAHA C O (1,3) ***** */
L220:
        ns = *n - s;
        z___ref(1, s - 1) = -ilambd;
        z___ref(1, s) = 0.;
        if (*n == 2) {
            goto L240;
        }
        rm1_ref(1, 3) = -ilambd;
        z___ref(1, s - 1) = 0.;
        if (*n == 3) {
            goto L240;
        }
        i__2 = *n;
        for (i__ = 4; i__ <= i__2; ++i__) {
            rm1_ref(1, i__) = 0.;
/* L230: */
        }
L240:
        i__2 = uk;
        for (i__ = 2; i__ <= i__2; ++i__) {
            mp = i__ - 1;
            w = rm1_ref(mp, i__);
            if (i__ < *n) {
                t = rm1_ref(mp, i__ + 1);
            }
            if (i__ == *n) {
                t = z___ref(mp, s - 1);
            }
            x2 = aa01p_c(&rm1_ref(mp, mp), &t);
            if (w <= x2) {
                goto L280;
            }
            x = rm1_ref(mp, mp) / w;
            y = t / w;
            rm1_ref(mp, mp) = w;
            if (i__ < *n) {
                rm1_ref(mp, i__ + 1) = 0.;
            }
            if (i__ == *n) {
                z___ref(mp, s - 1) = 0.;
            }
            i__3 = uk;
            for (j = i__; j <= i__3; ++j) {
                w = rm1_ref(j, i__);
                rm1_ref(j, i__) = rm1_ref(j, mp) - x * w;
                rm1_ref(j, mp) = w;
                if (j < n1) {
                    goto L250;
                }
                l = j - ns;
                z___ref(i__, l) = z___ref(mp, l) - y * w;
                z___ref(mp, l) = 0.;
                goto L260;
L250:
                rm1_ref(i__, j + 2) = rm1_ref(mp, j + 2) - y * w;
                rm1_ref(mp, j + 2) = 0.;
L260:
                ;
            }
            rm1_ref(i__, i__) = rm1_ref(i__, i__) - y * ilambd;
            if (i__ < n1) {
                goto L270;
            }
            l = i__ - ns;
            z___ref(mp, l) = -ilambd;
            z___ref(i__, l) = z___ref(i__, l) + x * ilambd;
            goto L340;
L270:
            rm1_ref(mp, i__ + 2) = -ilambd;
            rm1_ref(i__, i__ + 2) = rm1_ref(i__, i__ + 2) + x * ilambd;
            goto L340;
L280:
            if (x2 > eps4) {
                goto L290;
            }
            rm1_ref(mp, mp) = eps4;
            if (i__ < *n) {
                rm1_ref(mp, i__ + 1) = 0.;
            }
            if (i__ == *n) {
                z___ref(mp, s - 1) = 0.;
            }
            t = 0.;
            x2 = eps4;
L290:
            w = w / x2 / x2;
            x = rm1_ref(mp, mp) * w;
            y = -t * w;
            i__3 = uk;
            for (j = i__; j <= i__3; ++j) {
                if (j < n1) {
                    goto L300;
                }
                l = j - ns;
                t = z___ref(mp, l);
                z___ref(i__, l) = -x * t - y * rm1_ref(j, mp);
                goto L310;
L300:
                t = rm1_ref(mp, j + 2);
                rm1_ref(i__, j + 2) = -x * t - y * rm1_ref(j, mp);
L310:
                rm1_ref(j, i__) = rm1_ref(j, i__) - x * rm1_ref(j, mp) + y * 
                        t;
/* L320: */
            }
            if (i__ < n1) {
                goto L330;
            }
            l = i__ - ns;
            z___ref(i__, l) = z___ref(i__, l) - ilambd;
            goto L340;
L330:
            rm1_ref(i__, i__ + 2) = rm1_ref(i__, i__ + 2) - ilambd;
L340:
            ;
        }
        if (uk < n1) {
            goto L350;
        }
        l = uk - ns;
        t = z___ref(uk, l);
        goto L360;
L350:
        t = rm1_ref(uk, uk + 2);
L360:
        if ((d__1 = rm1_ref(uk, uk), abs(d__1)) <= eps4 && abs(t) <= eps4) {
            rm1_ref(uk, uk) = eps4;
        }
/* *****OPATHA OCTAHOBKA  KOM.C.B. */
/*     I=,UK,1,-1 */
L370:
        i__2 = uk;
        for (ii = 1; ii <= i__2; ++ii) {
            i__ = uk + 1 - ii;
            x = rv1[i__];
            y = 0.;
            if (i__ == uk) {
                goto L410;
            }
            ip1 = i__ + 1;
            i__3 = uk;
            for (j = ip1; j <= i__3; ++j) {
                if (j < n1) {
                    goto L380;
                }
                l = j - ns;
                t = z___ref(i__, l);
                goto L390;
L380:
                t = rm1_ref(i__, j + 2);
L390:
                x = x - rm1_ref(j, i__) * rv1[j] + t * rv2[j];
                y = y - rm1_ref(j, i__) * rv2[j] - t * rv1[j];
/* L400: */
            }
L410:
            if (i__ < n1) {
                goto L420;
            }
            l = i__ - ns;
            t = z___ref(i__, l);
            goto L430;
L420:
            t = rm1_ref(i__, i__ + 2);
L430:
            aa02p_c(&x, &y, &rm1_ref(i__, i__), &t, &rv1[i__], &rv2[i__]);
/* L440: */
        }
/* *****POBEPKA BCEHHOO C.B.  EO HOPMPOBKA */
L450:
        ++its;
        norm = 0.;
        normv = 0.;
        i__2 = uk;
        for (i__ = 1; i__ <= i__2; ++i__) {
            if (ilambd == 0.) {
                x = (d__1 = rv1[i__], abs(d__1));
            }
            if (ilambd != 0.) {
                x = aa01p_c(&rv1[i__], &rv2[i__]);
            }
            if (normv >= x) {
                goto L460;
            }
            normv = x;
            j = i__;
L460:
            norm += x;
/* L470: */
        }
        if (norm < growto) {
            goto L500;
        }
/* *****EMEM BEKTOP***** */
        x = rv1[j];
        if (ilambd == 0.) {
            x = 1. / x;
        }
        if (ilambd != 0.) {
            y = rv2[j];
        }
        i__2 = uk;
        for (i__ = 1; i__ <= i__2; ++i__) {
            if (ilambd != 0.) {
                goto L480;
            }
            z___ref(i__, s) = rv1[i__] * x;
            goto L490;
L480:
            aa02p_c(&rv1[i__], &rv2[i__], &x, &y, &z___ref(i__, s - 1), &
                    z___ref(i__, s));
L490:
            ;
        }
        if (uk == *n) {
            goto L550;
        }
        j = uk + 1;
        goto L530;
/* *****OCTPOEHE HOBOO HAAHOO B. */
L500:
        if (its >= uk) {
            goto L520;
        }
        x = ukroot;
        y = eps3 / (x + 1.);
        rv1[1] = eps3;
        i__2 = uk;
        for (i__ = 2; i__ <= i__2; ++i__) {
            rv1[i__] = y;
/* L510: */
        }
        j = uk - its + 1;
        rv1[j] -= eps3 * x;
        if (ilambd == 0.) {
            goto L180;
        }
        goto L370;
/* *****ATAHA OKA:HE O OYEHO EMEMOO C.B. */
L520:
        j = 1;
        *ierr = -k;
/* *****CBABAHE HYEBX HAEH OCTABMC KOMOHEHTAM */
L530:
        i__2 = *n;
        for (i__ = j; i__ <= i__2; ++i__) {
            z___ref(i__, s) = 0.;
            if (ilambd != 0.) {
                z___ref(i__, s - 1) = 0.;
            }
/* L540: */
        }
L550:
        ++s;
L560:
        if (ip == -1) {
            ip = 0;
        }
        if (ip == 1) {
            ip = -1;
        }
/* L570: */
    }
    goto L590;
/* *****ATAHA OKA: CTOOB MACCBA Z HE XBATAET  PAMEEH */
/*     BCEX TPEYEMX C.B.****** */
L580:
    if (*ierr != 0) {
        *ierr -= *n;
    }
    if (*ierr == 0) {
        *ierr = -((*n << 1) + 1);
    }
L590:
    *m = s - 1 - abs(ip);
    if (*ierr != 0) {
        utae12_c(ierr, n, &c__9);
    }
    return 0;
} /* aet3d_c */

#undef rm1_ref
#undef z___ref
#undef a_ref
